/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.personenpruefung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.personenpruefung.entity.ExternerAbgleich;
import de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichUK;

public abstract class AbstractExternerAbgleichDAO extends de.ivu.elect.jee.entity.AbstractDAO<ExternerAbgleich,
        de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichPK
    , ExternerAbgleichUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractExternerAbgleichDAO.class);

  public AbstractExternerAbgleichDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public ExternerAbgleich findByPrimaryKey(
        de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected ExternerAbgleich findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(ExternerAbgleich.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: CountByUnterstuetzerWahlAndStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM ExternerAbgleich o WHERE o.personendaten.wahl = ?1 AND o.externerAbgleichStatus IN (?2) AND EXISTS (SELECT u FROm WahlvorschlagsPerson u WHERE u=o.personendaten AND u.wahlvorschlagsPersonTyp = de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER)<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountByUnterstuetzerWahlAndStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichStatus> externerAbgleichStatus) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichStatus> externerAbgleichStatusCheckedAndAttached =  externerAbgleichStatus ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("EXTERNER_ABGLEICH.CountByUnterstuetzerWahlAndStatus")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, externerAbgleichStatusCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountByUnterstuetzerWahlAndStatus - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("ExternerAbgleich, findByCountByUnterstuetzerWahlAndStatus - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", externerAbgleichStatus:'"+externerAbgleichStatus+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountByUnterstuetzerWahlAndStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountByWahlAndStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM ExternerAbgleich o WHERE o.personendaten.wahl = ?1 AND o.externerAbgleichStatus IN (?2)<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountByWahlAndStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichStatus> externerAbgleichStatus) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichStatus> externerAbgleichStatusCheckedAndAttached =  externerAbgleichStatus ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("EXTERNER_ABGLEICH.CountByWahlAndStatus")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, externerAbgleichStatusCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountByWahlAndStatus - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("ExternerAbgleich, findByCountByWahlAndStatus - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", externerAbgleichStatus:'"+externerAbgleichStatus+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountByWahlAndStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlMaxDateNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT MAX(o.abfrageZeitpunkt) FROM ExternerAbgleich o WHERE o.personendaten.wahl=?1<br>
      * SQL: <br>
      */
     public java.util.Date findByWahlMaxDate( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (java.util.Date)
                              getEntityManager().
                                createNamedQuery("EXTERNER_ABGLEICH.WahlMaxDate")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("ExternerAbgleich, findByWahlMaxDate - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlMaxDate(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichUK uk,
        de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.personenpruefung.entity.ExternerAbgleich findByUK(de.ivu.elect.business.personenpruefung.entity.ExternerAbgleichUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}